-----------------------------------------------------------------
----------------------- SOME COMMENTS BEFORE WE BEGIN -----------
-----------------------------------------------------------------
--[[
* This is ins:Stacker by instant
* a fast attempt to stack items TO or FROM your bank. 
]]--

insSTACK = {}

insSTACK.name = "insStacker"
insSTACK.version = 0.3

		local  colWhite     = "|cFFFFFF" -- white (c1)
    local  colYellow    = "|cFFFF00" --yellow (c2)
    local  colGreen     = "|c00FF00" --green (c3)
		local  colTeal      = "|c00FFFF" -- teal (c4)
		local  colRed       = "|cFF0000" -- Red

--------------------------------------------------------------------
---  rundown function
--       input: 
--       output: tables containing items
--Purpose: list all items in bank/bag and compare them
--------------------------------------------------------------------
local function rundown(destination)
		insSTACK.hive = {}
		local i, x, name, stack
		for i = 1, GetMaxBags() do
				local bagitem={}
				local texture, number = GetBagInfo(i)	
				for x = 0, number do
						local item={}
						name=GetItemLink(i,x)
						stack=GetSlotStackSize(i,x)
						if name~="" and stack>0 then
							item.bag=i
							item.slot=x
							item.stack=stack
							if insSTACK.debug==1 then d("Slot:"..tostring(x).." : "..name) end
							table.insert(bagitem, item)
						end
				end
				table.insert(insSTACK.hive, bagitem)
		end
end

--------------------------------------------------------------------
---  banksy function
--
-- Purpose: When the user opens the bank, banksy takes a peek
--------------------------------------------------------------------
local function Banksy()
		if insSTACK.debug==1 then  d("Bank is opened :-)") end
		rundown()
end

--------------------------------------------------------------------
---  movit function
--       input: destination (bank or bag)
--
-- Purpose: Move items between source and target.
--          ClearCursor to make sure the user hasn't got any
--          items "picked up". 
--------------------------------------------------------------------
local function movit(bag1, slot1, bag2, slot2, count)
		if insSTACK.debug==1 then d(frombag.."-"..fromslot.."-"..tobag.."-"..toslot.."-"..count) end
    local status = true
    ClearCursor()
    status = CallSecureProtected("PickupInventoryItem", bag1, slot1, count)
    if (status) then status = CallSecureProtected("PlaceInInventory", bag2, slot2) end
    ClearCursor()
end



--------------------------------------------------------------------
---  shortcompare function
--    input: slot1 and slot2
--
-- Purpose: compare the list of inventory items to see which are
--          in both bags, return true if they are. 
--     if itemlink comparison fails for some reason, we try with
--     itemname, with added checks for the art icon, sell price and
--     quality to ensure we have the correct item.
--------------------------------------------------------------------
local function shortcompare(x, y)
		x1 = tonumber(x) 
		y1 = tonumber(y) 
		if insSTACK.hive[1][1]==nil then rundown() end -- if we have no items listed, do it.
		if insSTACK.hive[2][1]==nil then return end -- we need two bags to do a compare. 

				local bag1=tonumber(insSTACK.hive[1][x].bag)
				local slot1=tonumber(insSTACK.hive[1][x].slot)
				local stack1=tonumber(insSTACK.hive[1][x].stack)
				local link1=GetItemLink(bag1, slot1)
				local name1=GetItemName(bag1, slot1)

				local bag2=tonumber(insSTACK.hive[2][y].bag)
				local slot2=tonumber(insSTACK.hive[2][y].slot)
				local stack2=tonumber(insSTACK.hive[2][y].stack)
				local link2=GetItemLink(bag2, slot2)
				local name2=GetItemName(bag2, slot2)
		
		if insSTACK.debug==2 then d("["..x.."]".." ["..bag1.."]:["..slot1.."] ["..stack1.."]"..link1) end
		if insSTACK.debug==2 then d("["..y.."]".." ["..bag2.."]:["..slot2.."] ["..stack2.."]"..link2) end
		
		if link1==link2 then 
			if insSTACK.debug==1 then d("Link is a match!") end
			return true
		end
		if name1==name2 then 
			if insSTACK.debug==1 then d("Name is a match!") end
			-- since a name isn't a good indication that we have the correct item we need to investigate further		
			local art1,stack1,price1,usage1,locked1, equiptype1, itemstyle1, quality1 = GetItemInfo(bag1,slot1)
			local art2,stack2,price2,usage2,locked2, equiptype2, itemstyle2, quality2 = GetItemInfo(bag2,slot2)
			
			if art1==art2 then
				if price1==price2 then
					if quality1==quality2 then
						return true
					end
				end
			end
		end
end


--------------------------------------------------------------------
---  comparebags function
--    input: target if we want to send some items to the other bag
--
-- Purpose: compare the list of inventory items to see which are
--          in both bags.
--------------------------------------------------------------------
local function comparebags(target)
		d("Comparing Bags.")
		local count1, value1,stack1, count2,value2,stack2
		if insSTACK.hive[1][1]==nil then rundown() end -- if we have no items listed, do it.
		if insSTACK.hive[2][1]==nil then return end -- we need two bags to do a compare. 
		for count1,value1 in pairs(insSTACK.hive[1]) do
				for count2,value2 in pairs(insSTACK.hive[2]) do
						local result=shortcompare(count1, count2)
						if result==true then					
								local stack1=tonumber(insSTACK.hive[1][count1].stack)
								local stack2=tonumber(insSTACK.hive[2][count2].stack)
								local link1=GetItemLink(insSTACK.hive[1][count1].bag, insSTACK.hive[1][count1].slot)
								local link2=GetItemLink(insSTACK.hive[2][count2].bag, insSTACK.hive[2][count2].slot)
								local bag1=tonumber(insSTACK.hive[1][count1].bag)
								local slot1=tonumber(insSTACK.hive[1][count1].slot)
								local stack1=tonumber(insSTACK.hive[1][count1].stack)
								local bag2=tonumber(insSTACK.hive[2][count2].bag)
								local slot2=tonumber(insSTACK.hive[2][count2].slot)
								local stack2=tonumber(insSTACK.hive[2][count2].stack)
								
								if target=="" or target==nil then 
									d("Matched: "..stack1.." x "..link1.."(in bags) with "..stack2.." x "..link2.."(in bank)") 
								end
								if target=="bag" then
										if stack1+stack2<101 then 
											d(colWhite.."Moving"..colYellow.." ["..colGreen..stack2..colYellow.." x "..link2..colYellow.."]"..colWhite.." to Bag")										
											if insSTACK.debug==1 then  d(bag2..":"..slot2..":"..bag1..":"..slot1..":"..stack2) end
											movit(bag2, slot2, bag1, slot1, stack2) -- source, target, countsource
										end
								elseif target=="bank" then
										if stack1+stack2<101 then 
											d(colWhite.."Moving"..colYellow.." ["..colGreen..stack1..colYellow.." x "..link1..colYellow.."]"..colWhite.." to Bank")										
											if insSTACK.debug==1 then  d(bag1..":"..slot1..":"..bag2..":"..slot2..":"..stack1) end
											movit(bag1, slot1, bag2, slot2, stack1) -- source, target, countsource
										end
								end
						end
				end
		end
end


--------------------------------------------------------------------
---  commandHandler function
--       input: text (Commands)
--------------------------------------------------------------------
local function commandHandler(text)
  local input = string.lower(text)
  local com = {}
  local index = 1
  if text~=nil then
  	for value in string.gmatch(input,"%w+") do  
  		  com[index] = value
	    	index = index + 1
		end
	end
  if com[1]=="rundown" then
 		rundown()		
 	elseif com[1]=="bag" then	
 		comparebags(com[1])
 	elseif com[1]=="bank" then	
 		comparebags(com[1]) 		
 	elseif com[1]=="compare" then
 		comparebags(com[2])
 	elseif com[1]=="set" then
 		if com[2]=="debug" then
 		  d(com[1]..com[2]..com[3])
 			insSTACK.debug=tonumber(com[3])
 		end
 	elseif com[1]=="sc" then
 		shortcompare(com[2], com[3])
  else
  	d("try: /stacker compare [bag/bank] with bank open. ")
  	d("or /stacker [bag/bank] to save time. ")
  	d("The [bag] or [bank] argument move items TO that location.")
  end
end -- We end our function


--------------------------------------------------------------------
---  insSTACK.Initialize function
--       input: eventCode, addOnName
--------------------------------------------------------------------
local function Intro()
		EVENT_MANAGER:UnregisterForEvent("insSTACK",EVENT_PLAYER_ACTIVATED)
		d(colWhite.."ins"..colYellow..":"..colGreen.."Stacker"..colWhite.." has loaded. Type "..colYellow.."/stacker"..colWhite.." for help.")
end

--------------------------------------------------------------------
---  insSTACK.Initialize function
--       input: eventCode, addOnName
--------------------------------------------------------------------
local function Initialize( eventCode, addOnName )
	if ( addOnName ~= insSTACK.name ) then return end
		insSTACK.vars		= {	}
		insSTACK.SV = ZO_SavedVars:New("insSTACK_SV" , 1 , nil , insSTACK.vars, nil )            

		-- We register our slash command
		SLASH_COMMANDS["/stacker"] = commandHandler

		-- we unregister for the event as the addon is loaded.
		EVENT_MANAGER:UnregisterForEvent("insSTACK",EVENT_ADD_ON_LOADED)
end  -- end of insADD2.Initialize function

-- We register an event to initialize the addon, and another to spam a message on load.
EVENT_MANAGER:RegisterForEvent("insSTACK",EVENT_ADD_ON_LOADED,Initialize)
EVENT_MANAGER:RegisterForEvent("insSTACK",EVENT_PLAYER_ACTIVATED,Intro)
EVENT_MANAGER:RegisterForEvent("insSTACK",EVENT_OPEN_BANK,Banksy)